
class Mob { 
  float X,Y,lookAtX,lookAtY,targetX,targetY,timer,delay;
  float health,age,food,water,stomach;
  boolean kill;
  boolean carriesPoop;
  boolean carriesEgg;
  int need;
  
  
  Mob(float startX,float startY,float _age) {
    X = startX;
    Y = startY;
    targetX=random(X-300,X+300);
    targetY=random(Y-300,Y+300);
    lookAtX = X;
    lookAtY = Y;
    delay=25;
    timer=millis()+ random(delay);
    age=_age;
    health=0.5+random(0.5);
    food=random(1);
    water=random(0.7);
    stomach=random(0.5);
    need=0;
    carriesPoop=false;
    kill = false;
  } 
  void update() {
    if(timer+delay<millis()){
      delay=10+random(10)+((1.05-health)*100);
      timer=millis();
      status();
      if(!kill){
        switch (need){
          case 0:
            randomTarget();
            break;
          case 1:
            foodTarget();
            break;
          case 2:
            waterTarget();
            break;
          default:
          break;
        }
        moveByTarget();
      }
    }
  }
  
  void status(){
    age+=0.001;
    food-=0.0005;
    if(random(1)<0.1){water-=0.005;}
    
    if(health<0){
      killMe();
    }
    
    if(food<0.1){
      need=1;
      color _trail = adjustColor(foodMap.get(int(X),int(Y)),-1,-1,-1);
      foodMap.set(int(X),int(Y), _trail );
      //println("hungry!");
      if(food<0){health-=0.01;}
    }else{
      color _trail = adjustColor(foodMap.get(int(X),int(Y)),int(food*2.0),int(food*2.0),int(food*2.0));
      foodMap.set(int(X),int(Y), _trail );
    }
    if(stomach > 0.4){
      color _trail = adjustColor(foodMap.get(int(X),int(Y)),int(food*2.0),int(food*2.0),int(food*2.0));
      foodMap.set(int(X),int(Y), _trail );
    }
    
    if(water<0.2){
      //println("thirsty!");
      need=2;
      color _trail = adjustColor(waterMap.get(int(X),int(Y)),-1,-1,-1);
      waterMap.set(int(X),int(Y), _trail );
      if(water<0){health-=0.01;}
    }else{
      color _trail = adjustColor(waterMap.get(int(X),int(Y)),int(water*5),int(water*5),int(water*5));
      waterMap.set(int(X),int(Y), _trail );
    }
    
    if(food>0.2 && water>0.2){
      need=0;
    }
    
    if(age>1){
      health-=0.01;
    }
  }
  
  void moveByTarget(){
    float xDiff = X-targetX;
    float yDiff = Y-targetY;
    float xR = abs(xDiff)/(abs(xDiff)+abs(yDiff));
    float yR = abs(yDiff)/(abs(xDiff)+abs(yDiff));
    
    if(random(1)<xR){
      lookAtX = (xDiff < 0) ? X+1:X-1;
    }
    if(random(1)<yR){
      lookAtY = (yDiff < 0) ? Y+1:Y-1;
    }
    if( inBounds(int(lookAtX),int(lookAtY)) ){
      if(collisionMap.get(int(lookAtX),int(lookAtY))== WHITE){
        collisionMap.set(int(lookAtX),int(lookAtY),GROBBLING);
        collisionMap.set(int(X),int(Y),WHITE);
        /*
        if(random(1)<0.01 && food > 0.8){
          collisionMap.set(int(X),int(Y),POOP);
        }
        */
        X=lookAtX;
        Y=lookAtY;
      }else{
        if(collisionMap.get(int(lookAtX),int(lookAtY))== WATER){
          water=1;
        }
        if(collisionMap.get(int(lookAtX),int(lookAtY))== GROBBLING){
          if(water>0.7 && food >0.7 && age >0.5 && health > 0.6 && brightness(waterMap.get(int(X),int(Y))) < 100){
            int _x = int(random(-2,2));
            int _y = int(random(-2,2));
            if(collisionMap.get(int(X+_x),int(Y+_y))==WHITE){
              //println("make baby grobbling!");
              health-=0.1;
              collisionMap.set(int(X+_x),int(Y+_y),EGG);
            }
          }
        }
        if(collisionMap.get(int(lookAtX),int(lookAtY))== SHROOM && food < 0.5){
          food=1;
          stomach=1;
          collisionMap.set(int(lookAtX),int(lookAtY),WHITE);
        }
        /*
        if(collisionMap.get(int(lookAtX),int(lookAtY))== EGG && !carriesEgg){
          carriesEgg=true;
          collisionMap.set(int(lookAtX),int(lookAtY),WHITE);
        }*/
        if(carriesEgg){
          if(collisionMap.get(int(lookAtX),int(lookAtY))== EGG || collisionMap.get(int(lookAtX),int(lookAtY))== BLACK){
            carriesEgg=false;
            collisionMap.set(int(X),int(Y),EGG);
          }
        }
        if(collisionMap.get(int(lookAtX),int(lookAtY))== BLACK || collisionMap.get(int(lookAtX),int(lookAtY))== POOP){
          if(stomach>0.3){
            stomach-=0.4;
            collisionMap.set(int(X),int(Y),POOP);
          }
        }
        if(collisionMap.get(int(lookAtX),int(lookAtY))== BOMB){
          killMe();
          anims.add(new multiAnimObject(multiSpriteMap, 16, 16, int(X-8),int(Y-8), 0.2, 0));
          //println(int(X-8));
          for(int _g=mobs.size()-1;_g>=0;_g--){
            Mob _m = (Mob) mobs.get(_g);
            if(distance(_m.X,_m.Y,X,Y)<50){
              _m.killMe();
            }
          }
          for(int _y=0;_y<hole.height;_y++){
            for(int _x=0;_x<hole.width;_x++){
              if(hole.get(_x,_y)==WHITE){
                //println(_x);
                collisionMap.set(int(X-8)+_x, int(Y-8)+_y, WHITE);
              }
            }
          }
          //collisionMap.copy(hole, 0, 0, 16, 16, int(X)-8, int(Y)-8, int(X)+8, int(Y)+8);
        }
        if(collisionMap.get(int(lookAtX),int(lookAtY))== POOP && !carriesPoop){
          //println("poop!");
          carriesPoop=true;
          collisionMap.set(int(lookAtX),int(lookAtY),WHITE);
        }
        if(carriesPoop){
          if(collisionMap.get(int(lookAtX),int(lookAtY))== POOP || collisionMap.get(int(lookAtX),int(lookAtY))== SHROOM || collisionMap.get(int(lookAtX),int(lookAtY))== BLACK){
            //println("more poop!");
            carriesPoop=false;
            collisionMap.set(int(X),int(Y),POOP);
          }
        }
        if(!kill){
          lookAtX=X+int(random(-2,2));
          lookAtY=Y+int(random(-2,2));
          if( inBounds(int(lookAtX),int(lookAtY)) ){
            if(collisionMap.get(int(lookAtX),int(lookAtY))== WHITE){
              collisionMap.set(int(lookAtX),int(lookAtY),GROBBLING);
              if(collisionMap.get(int(X),int(Y))==POOP){
                //collisionMap.set(int(X),int(Y),POOP);
              }else{
                collisionMap.set(int(X),int(Y),WHITE);
              }
              targetX=random(X-300,X+300);
              targetY=random(Y-300,Y+300);
              X=lookAtX;
              Y=lookAtY;
            }
          }
        }
      }
    }
  }
  void killMe(){
    println("dies at age:",age,"water:",water,"food:",food,"health:",health);
    collisionMap.set(int(X),int(Y),WHITE);
    kill=true;
  }
  void randomTarget(){
  }
  void foodTarget(){
    int _x = int(random(-5,5));
    int _y = int(random(-5,5));
    boolean _success = false;
    color _compare=foodMap.get(int(X),int(Y));
    for(int _i=0;_i<15;_i++){
      if(inBounds(int(X+_x),int(Y+_y)) && !_success){
        if( foodMap.get(int(_x+X),int(_y+Y)) > _compare ){
          _compare=foodMap.get(int(_x+X),int(_y+Y));
          targetX=_x+X;
          targetY=_y+Y;
           _x = int(random(-5,5));
           _y = int(random(-5,5));
          if(collisionMap.get(int(_x+X),int(_y+Y)) == SHROOM){
            targetX=_x+X;
            targetY=_y+Y;
            _success=true;
          }
        }
      }
    }
    /*
    for(int _i=0;_i<60;_i++){
      int _x = int(random(-15,15));
      int _y = int(random(-15,15));
      if(inBounds(int(X+_x),int(Y+_y))){
        if(collisionMap.get(int(X+_x),int(Y+_y)) == SHROOM){
          targetX=_x+X;
          targetY=_y+Y;
        }
      }
    }*/
  }
  void waterTarget(){
    int _x = int(random(-5,5));
    int _y = int(random(-5,5));
    boolean _success = false;
    color _compare=waterMap.get(int(X),int(Y));
    for(int _i=0;_i<15;_i++){
      if(inBounds(int(X+_x),int(Y+_y)) && !_success){
        if( waterMap.get(int(_x+X),int(_y+Y)) > _compare ){
          _compare=waterMap.get(int(_x+X),int(_y+Y));
          targetX=_x+X;
          targetY=_y+Y;
          _x = int(random(-5,5));
           _y = int(random(-5,5));
          if(collisionMap.get(int(_x+X),int(_y+Y)) == WATER){
            targetX=_x+X;
            targetY=_y+Y;
            _success=true;
          }
        }
      }
    }
  }
} 

class multiAnimObject {
  PImage spriteMap;
  PImage[][] images;
  float currentFrame, currentAnimation;
  float frame,animation;
  float pace;
  int xpos;
  int ypos;
  boolean finished = false;
  
  multiAnimObject(PImage sprMap, int sprWidth, int sprHeight, int mx, int my, float p, int _anim) { // initialize a new object. Why is the double initialization done? Compare count->imageCount to sprWidth is only sprWidth.
    spriteMap = sprMap;
    xpos = mx;
    ypos = my;
    pace = p;

    animation = spriteMap.height/sprHeight;
    frame = spriteMap.width/sprWidth;
    images = new PImage[int(animation)][int(frame)];
    currentFrame=0;
    currentAnimation=_anim;
    for (int a = 0; a < animation; a++) {
      for (int i = 0; i < frame; i++) {
        //println("a: "+ a + ", i: " + i);
        images[a][i] = createImage(sprWidth, sprHeight, ARGB);
        images[a][i].copy(spriteMap,i*sprWidth,a*sprHeight,sprWidth,sprHeight,0,0,sprWidth,sprHeight); 
      }
    }
  }
  
  multiAnimObject setDelay(float delay) {
    currentFrame = -delay;
    return this;
  }

  void display(float xpos, float ypos) {
    currentFrame = (currentFrame+pace);
    if (int(currentFrame) >= frame){
      finished=true;
    } else {
      if (currentFrame < 0) {
        return;
      }
      image(images[int(currentAnimation)][int(currentFrame)], xpos, ypos);
    }
  }
}
